package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Sound;
	import flash.utils.Dictionary;
	
	import starling.text.BitmapFont;
	import starling.text.TextField;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;

	public class Assets
	{	
		
		[Embed(source = '../media/sfx/theme.mp3', mimeType = "audio/mpeg")]	
		public static var themeClass:Class;
		public static const theme_sound:Sound=new themeClass();
		
		[Embed(source = '../media/sfx/explosion.mp3', mimeType = "audio/mpeg")]	
		public static var explClass:Class;
		public static const expl_sound:Sound=new explClass();
		
		[Embed(source = '../media/sfx/rocket.mp3', mimeType = "audio/mpeg")]	
		public static var rocketClass:Class;
		public static const rocket_sound:Sound=new rocketClass();
		
		[Embed(source = '../media/sfx/copter.mp3', mimeType = "audio/mpeg")]	
		public static var copterClass:Class;
		public static const copter_sound:Sound=new copterClass();	
		
		[Embed(source = '../media/sfx/shoot.mp3', mimeType = "audio/mpeg")]	
		public static var shootClass:Class;
		public static const shoot_sound:Sound=new shootClass();	
		
		[Embed(source = '../media/sfx/gun.mp3', mimeType = "audio/mpeg")]	
		public static var gunShootClass:Class;
		public static const gun_sound:Sound=new gunShootClass();	
		
		[Embed(source = '../media/sfx/napalm.mp3', mimeType = "audio/mpeg")]	
		public static var napalmClass:Class;
		public static const napalm_sound:Sound=new napalmClass();
		
		[Embed(source = '../media/sfx/pickShells.mp3', mimeType = "audio/mpeg")]	
		public static var pickShells:Class;
		public static const pickShells_sound:Sound=new pickShells();
		
		[Embed(source = '../media/sfx/shield.mp3', mimeType = "audio/mpeg")]	
		public static var shieldClass:Class;
		public static const shield_sound:Sound=new shieldClass();	
		
		[Embed(source = '../media/sfx/on.mp3', mimeType = "audio/mpeg")]	
		public static var GirlTransformClass:Class;
		public static const transform_sound:Sound=new GirlTransformClass();	
		
		[Embed(source = '../media/sfx/fist.mp3', mimeType = "audio/mpeg")]	
		public static var bareFistCl:Class;
		public static const bareFist:Sound=new bareFistCl();	
		
		[Embed(source = '../media/sfx/punch.mp3', mimeType = "audio/mpeg")]	
		public static var punchCl:Class;
		public static const punchFist:Sound=new punchCl();	
		
		[Embed(source = '../media/sfx/chpok.mp3', mimeType = "audio/mpeg")]	
		public static var chpokCl:Class;
		public static const chpok:Sound=new chpokCl();	
		
		[Embed(source = '../media/sfx/finished.mp3', mimeType = "audio/mpeg")]	
		public static var finishedCl:Class;
		public static const finished:Sound=new finishedCl();	
		
		[Embed(source = '../media/sfx/fall.mp3', mimeType = "audio/mpeg")]	
		public static var fallCl:Class;
		public static const fall:Sound=new fallCl();	
		
		[Embed(source = '../media/sfx/gameover.mp3', mimeType = "audio/mpeg")]	
		public static var goCl:Class;
		public static const gameoverSnd:Sound=new goCl();	
	
		
		//спрайтлист основной	
		[Embed(source="../media/gfx/sprites.png")]
		public static const atlasTexture:Class;		
		
		
		[Embed(source="../media/gfx/sprites.xml", mimeType ="application/octet-stream")]
		public static const atlasXML:Class;	

		
		[Embed(source="../media/gfx/logo.png")]
		public static const logoImg:Class;
		
		[Embed(source="../media/gfx/map.png")]
		private static const 	mapBMP:Class;
		private static const   	map_bitmap:Bitmap = new mapBMP();
		public static const		mapBD:BitmapData = map_bitmap.bitmapData;
		
		private static var gameTextures:Dictionary = new Dictionary(); 
		private static var gameTextureAtlas:TextureAtlas; 
	
//----------выборка единичной текстуры------------------------------------------------		
		public static function getTexture(name:String):Texture
		{
			if (gameTextures[name]== undefined)
			{			
				var bitmap:Bitmap = new Assets[name]();
				gameTextures[name] = Texture.fromBitmap(bitmap,false,false); //без мипмапов
			}
			return gameTextures[name];			
		}
		
//-----------загрузка основного атласа--------------------------------------------------
		public static function getAtlas():TextureAtlas
		{
			if (gameTextureAtlas==null)
			{
				var texture:Texture = getTexture("atlasTexture");
				var xml:XML = XML(new atlasXML());
				gameTextureAtlas = new TextureAtlas(texture,xml);
			}
			return gameTextureAtlas;	
		}

		public static function createShader(gWidth:int, gHeight:int, scale:int = 0):void
		{
			var render_rect:Rectangle = new Rectangle();
			var render_point:Point = new Point();
			var shaderBD:BitmapData = new BitmapData(gWidth,gHeight,true,0x00000000);
			
			var tmpBD:BitmapData;
			var i:int;
			var n:int;
			
			switch (scale)
			{
				case 2:
					tmpBD = new BitmapData(2,2,true,0x00000000);	
					tmpBD.setPixel32(0,1,0x40000000);
					tmpBD.setPixel32(1,1,0x40000000); 
					render_rect.width = render_rect.height 	=2;
					render_rect.x =render_rect.y =0;			
					for (i = 0; i < (gWidth*3)/2; i++) 
					{
						render_point.x = i*2;
						for (n = 0; n < (gHeight*3)/2; n++) 
						{			
							render_point.y = n*2;
							shaderBD.copyPixels(tmpBD,render_rect,render_point,null,null,true);
						}		
					}	
					break;	
				
				case 3:
					tmpBD = new BitmapData(3,3,true,0x00000000);	
					tmpBD.setPixel32(0,0,0x40FFFFFF);
					tmpBD.setPixel32(1,0,0x40FFFFFF);	
					tmpBD.setPixel32(2,0,0x40FFFFFF);
					tmpBD.setPixel32(0,1,0x40CCCCCC);
					tmpBD.setPixel32(1,1,0x40CCCCCC); 
					tmpBD.setPixel32(2,1,0x40CCCCCC);
					tmpBD.setPixel32(0,2,0x40000000); 					
					tmpBD.setPixel32(1,2,0x40000000);
					tmpBD.setPixel32(2,2,0x40000000);	
					render_rect.width =render_rect.height =3;
					render_rect.x =render_rect.y =0;
					
					for (i = 0; i < gWidth; i++) 
					{
						render_point.x = i*3;
						for (n = 0; n < gHeight; n++) 
						{			
							render_point.y = n*3;
							shaderBD.copyPixels(tmpBD,render_rect,render_point,null,null,true);
						}		
					}					
					break;
				case 4:
					tmpBD = new BitmapData(4,4,true,0x00000000);	
					tmpBD.setPixel32(0,0,0x40FFFFFF);
					tmpBD.setPixel32(1,0,0x40FFFFFF);
					tmpBD.setPixel32(2,0,0x40FFFFFF); 
					tmpBD.setPixel32(0,1,0x40FFFFFF);
					tmpBD.setPixel32(3,1,0x40000000);
					tmpBD.setPixel32(0,2,0x40FFFFFF); 
					tmpBD.setPixel32(3,2,0x40000000);
					tmpBD.setPixel32(1,3,0x40000000); 
					tmpBD.setPixel32(2,3,0x40000000);
					tmpBD.setPixel32(3,3,0x60000000);

					render_rect.width =render_rect.height =4;
					render_rect.x =render_rect.y =0;
					
					for (i = 0; i < gWidth; i++) 
					{
						render_point.x = i*4;
						for (n = 0; n < gHeight; n++) 
						{			
							render_point.y = n*4;
							shaderBD.copyPixels(tmpBD,render_rect,render_point,null,null,true);
						}		
					}			
					break;
				case 5:
					tmpBD = new BitmapData(5,5,true,0x00000000);	
					tmpBD.setPixel32(0,0,0x40FFFFFF);
					tmpBD.setPixel32(1,0,0x40FFFFFF);
					tmpBD.setPixel32(2,0,0x40FFFFFF); 
					tmpBD.setPixel32(3,0,0x40FFFFFF); 
					tmpBD.setPixel32(0,1,0x40FFFFFF);
					tmpBD.setPixel32(4,1,0x40000000);
					
					tmpBD.setPixel32(1,1,0x40FFFFFF);
					tmpBD.setPixel32(0,2,0x40FFFFFF); 
					tmpBD.setPixel32(4,2,0x40000000);
					tmpBD.setPixel32(0,3,0x40FFFFFF); 
					tmpBD.setPixel32(4,3,0x40000000);
					
					tmpBD.setPixel32(3,3,0x40000000);
					tmpBD.setPixel32(1,4,0x40000000); 
					tmpBD.setPixel32(2,4,0x40000000);
					tmpBD.setPixel32(3,4,0x40000000);
					tmpBD.setPixel32(4,4,0x60000000);
					render_rect.width =render_rect.height =5;
					render_rect.x =render_rect.y =0;
					
					for (i = 0; i < gWidth; i++) 
					{
						render_point.x = i*5;
						for (n = 0; n < gHeight; n++) 
						{			
							render_point.y = n*5;
							shaderBD.copyPixels(tmpBD,render_rect,render_point,null,null,true);
						}		
					}			
					break;					
			}
			
			if (gameTextures["netShader"]== undefined)
			{			
				  gameTextures["netShader"] = Texture.fromBitmapData(shaderBD,false);
			}	
			
			shaderBD.dispose();			
			if (tmpBD) tmpBD.dispose();
		}	
//----------------------------------------------------------------------------------		
		
	}
}