package
{
	
	import starling.display.BlendMode;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.Event;

	
	public class Game extends Sprite
	{
		private var mainMenu:MainMenu;
		private var runGame:RunGame;
		private var gameOver:GameOver;
		
		public static var  gameState:int =0;	
		public static var splash_logo:Image;
		public static var restart:Boolean = false;
		
		public function Game()
		{
			super();
			this.addEventListener(starling.events.Event.ADDED_TO_STAGE,onAddedToStage);
			this.touchable =false;	
		}
		
		private function onAddedToStage(e:Event):void
		{			
			this.addEventListener (starling.events.Event.ENTER_FRAME, onEnterFrame);
			
			mainMenu = new MainMenu();
			this.addChild(mainMenu);
			mainMenu.show();
			
			gameOver =new GameOver();
			this.addChild(gameOver);
			gameOver.hide();
			
			runGame = new RunGame();
			this.addChild(runGame);
			runGame.hide();
			
			Assets.createShader(GS.gameWidth*GS.scaleIndex, GS.gameHeight*GS.scaleIndex, 2);
			
			var netShader:Image =new Image(Assets.getTexture("netShader"));
			netShader.blendMode = BlendMode.MULTIPLY; 
			netShader.x= netShader.y =0;
			netShader.alpha= 0.99;
			this.addChild(netShader);		
		}		

		private function onEnterFrame():void
		{
			checkState();			
		}	
//-----------------------------------------------------------------------------------------------
		private var lastState:int =0;	
		[Inline]
		public final function checkState():void
		{ 

			if 	(gameState!=lastState) 
			{
				switch (lastState) 
				{
					case 0:
						mainMenu.hide();				
						break;	
					case 100:
						runGame.hide();				
						break;
					case 200:
						gameOver.hide();
						break;
				}				
				
				switch (gameState) 
				{
					case 0:
						mainMenu.show();
						break;
					case 100:
						if (restart) 
						{							
							runGame.show(true);
							restart=false;
						}
						else
						{
							runGame.show();
						}
						break;
					case 200:
						gameOver.show();
						break;
				}
				
				lastState = gameState;			
			}		
		}
	}
}