package gameClasses
{
	import starling.display.MovieClip;
	
	public class Bullet extends MovieClip
	{
		public var xx:Number =0;
		public var yy:Number =0;
		public var dx:Number =0;
		public var dy:Number =0;
		
		public var active:Boolean;
		public var direction:int =0;  // 0-вправо, 1-влево
		private static var cashe:Array =[];
		private static var activeBullets:Vector.<Bullet> = new Vector.<Bullet>();	
		private static var curBullet:Bullet;
		
		//---------------------------------------------------------------------------------
		
		public function Bullet()
		{
			super(Assets.getAtlas().getTextures("bullet_"));			
		}
		
		//--------------------------------------------------------------------------------
		
		public static function updateAll():void
		{
			var al:int = activeBullets.length;
			for (var i:int = 0; i < al; i++) 
			{
				curBullet = activeBullets[i];
				if (curBullet.active) curBullet.update();
				else 
				{
					activeBullets.splice(i,1);
					curBullet.toCashe();
					Sparks.add(curBullet.xx,curBullet.yy,3);
					al--;		
				}
			}		
		}		
		//--------------------------------------------------------------------------------
		
		public static function drawAll():void
		{
			var al:int = activeBullets.length;
			for (var i:int = 0; i < al; i++) 
			{
				curBullet = activeBullets[i];
				if (curBullet.x > 0 && curBullet.x < GS.gameWidth && curBullet.y>0 && curBullet.y< GS.gameHeight)	RunGame.canvas.draw(curBullet);
			}		
		}
		
		//--------------------------------------------------------------------------------		
		private function update():void
		{
			this.xx += this.dx;
			this.yy += this.dy;
			
			this.y = this.yy - RunGame.viewPoint.y-25;
			
			if (this.direction == 0)this.x = this.xx - RunGame.viewPoint.x-21;
			else this.x = this.xx - RunGame.viewPoint.x;
			
			if (Map.hasCollision(this.xx>>5, this.yy>>5)) this.active =false;
			
			if (this.x< 0 || this.x > GS.gameWidth) this.active =false;

			if (Man.hitRect.contains(this.xx,this.yy))
			{
				Sparks.add(Man.xx+16, Man.yy-30,1);
				this.active=false;
				Man.mojo -=30;
				RunGame.tintQuad.alpha = 0.55;
				RunGame.tintQuad.color = 0xFF0000;
			}
			
		}
		
		//--------------------------------------------------------------------------------	
		public final function toCashe():void
		{
			this.visible =false;				
			cashe.push(this);			
		}

		
		public static function getOne(direction:int =0, x:int=0, y:int =0):void
		{
			curBullet= cashe.shift();
			if (!curBullet)
			{
				curBullet = new Bullet();	
			}	
				
			curBullet.xx= x;
			curBullet.yy= y;
			
			if (direction==0)curBullet.dx = 12.9;
			else curBullet.dx = -12.9;
			
			curBullet.dy = -0.30 + Math.random()*0.6;
			
			curBullet.direction 	= direction;
			curBullet.currentFrame 	= direction;
			curBullet.active  		= true;
			curBullet.visible 		= true;
			curBullet.alpha 		= 0.999;
			activeBullets.push(curBullet);

		}		
//----------------------------------------------------------------------			
		
	}
}