package gameClasses
{	
	import starling.display.MovieClip;
	import starling.display.Sprite;
	
	public class Effect extends Sprite
	{
		private var movie:MovieClip;
		private var animation:Array;
		private var animCounter:int =0;
		public var active:Boolean;
		public var type:int;
		private var permanent:Boolean = false;
		private var repeatCount:int =1; 
		private var repeats:int =1; 
		
		
		public var xx			: Number;
		public var yy			: Number;
		public var cx			: Number; 
		public var cy			: Number;
		
		
		private static var cashe:Array =[];
		private static var activeEffects:Vector.<Effect> = new Vector.<Effect>();
		
		//----------------------------------------------------
		public function Effect(type:int, x:Number=0, y:Number=0)
		{
			super();
			this.type = type;		
			this.xx = x;
			this.yy = y;			
			this.cx = x>>4;
			this.cy = y>>4;			
	
			
			
			this.animCounter 	= 0;
			var rnd:Number= Math.random();
			
			switch (type)
			{
				case 0: 
					
					this.animation 			= [4,5,6,7,8,9,10,11,12,13,14,0,1,2,3];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("boom1_"));
					this.movie.x = Math.ceil(-this.movie.width/2); 
					this.movie.y = Math.ceil(-this.movie.height/2);
					this.movie.color =0xFF0000;
					this.movie.alpha =0.99;
					this.permanent = false;
					this.repeatCount =1;					
					break;
				case 1:				
					break;				
				case 2:
					break;
				case 3: 					
					this.animation 			= [0,1,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("dust_"));
					this.movie.x = Math.ceil(-this.movie.width/2); 
					this.movie.y = Math.ceil(-this.movie.height/2);
					this.movie.alpha =0.8;	
					this.movie.color =0xFFFFFF;
					this.permanent = false;
					this.repeatCount =1;
					break;
				
				case 4: 
					
					this.animation 			= [0,0,1,1,2,2,3,3,3,0];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("flame_"));
					this.movie.alpha =0.8;	
					this.permanent = false;
					this.repeatCount = 3+Math.random()*6;
					break;
				
				case 5: 			
					this.animation 			= [0,1,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,10];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("dust16x8_"));
					this.movie.x = Math.ceil(-this.movie.width/2); 
					this.movie.y = 0;
					this.movie.alpha =0.90;	
					this.movie.color =0xFFFFFF;
					this.permanent = false;
					this.repeatCount =1;
					break;
				
				case 6: 			
					this.animation 			= [0,0,0,1,1,1,2,2,2,3,3,3,4,4,4];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("smoke16x32_"));
					this.movie.x = Math.ceil(-this.movie.width/2); 
					this.movie.y = -16;
					this.movie.alpha =0.20+ Math.random()*0.3;	
					this.movie.color =0xFFFFFF;
					this.permanent = false;
					this.repeatCount = 10+Math.random()*6;
					this.animCounter 	= int(Math.random()*4);
					break;
				case 7: 			
					this.animation 			= [0,0,1,1];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("boom16x16_"));
					this.movie.x = Math.ceil(-this.movie.width/2);
					this.movie.y = Math.ceil(-this.movie.height/2);  
					this.movie.alpha =0.8;	
					this.movie.color =0x320000;
					this.permanent = false;
					this.repeatCount =1;
					this.animCounter 	= 0;
					break;	
				case 8: 
					this.animation 			= [0,0,1,1,2,2,3,3];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("blueSparks_")); 
					this.movie.alpha =0.999;	
					this.permanent = true;
					this.animCounter 	= 0;
					break;	
				case 10: 		
					this.animation 			= [0,0,1,1,2,2,2,3,3,4,5,6,7,8,9];	
					this.movie	= new MovieClip(Assets.getAtlas().getTextures("transformSparks_"));
					this.movie.x = Math.ceil(-this.movie.width/2); 
					this.movie.y = Math.ceil(-this.movie.height/2);  
					this.movie.alpha =0.8;						
					this.permanent = false;
					this.repeatCount = 1;
					this.animCounter = 0;
					break;				
				default:
					break;		
			}
			this.addChild(this.movie);			
		}
		
//-------------------------------------------------------------------		
		public static function clear():void
		{
			var e:Effect;
			for (var i:int = 0; i < activeEffects.length; i++) 
			{
				e= activeEffects[i];
				var cy:uint = e.yy>>4; 
				e.active =false;
				activeEffects.splice(i,1);
				e.toCashe();						 
				if (e.type == 4 && cy< Map.maxCY)Map.collisionMap[cy][e.xx>>4] = 0xffffff;	
			}
			activeEffects.length =0;
		}
//---------------------------------------------------------
		public static function updateAll():void
		{	
			var e:Effect;
			for (var i:int = 0; i < activeEffects.length; i++) 
			{
			 e= activeEffects[i];
			 var cy:uint = e.yy>>4; 
			 
			 if (e.animCounter<e.animation.length)
			 {							
				 e.movie.currentFrame = e.animation[e.animCounter];		
				 e.animCounter++;	
				 e.x = e.xx - RunGame.viewPoint.x;
				 e.y = e.yy - RunGame.viewPoint.y+1;
			 }
			 else
			 {   
				 if (!e.permanent)
				 {
					 e.animCounter =0;
					 e.repeats--;
					 if (e.repeats <=0)
					 {
						 e.active =false;
						 activeEffects.splice(i,1);
						 e.toCashe();						 

						 if (e.type == 4 && cy< Map.maxCY)
						 {
							 Map.collisionMap[cy][e.xx>>4] = 100; //пусто	
						 }
						 continue;
					 }					 
				 }
				 else
				 {
					 e.animCounter =0;
				 }
			 }
			 if (e.type == 4  && cy+1< Map.maxCY)
			 {
				 if (Map.collisionMap[cy+1][e.xx>>4] >=100)
				 {	
				 Map.collisionMap[cy][e.xx>>4] = 100;		 
				 e.active =false;
				 activeEffects.splice(i,1);
				 e.toCashe();
				 }
			 }
			 else if (e.type == 6 && cy+1< Map.maxCY)
			 {
				 if (Map.collisionMap[cy+1][e.xx>>4] >=100)
				 {	
					 e.active =false;
					 activeEffects.splice(i,1);
					 e.toCashe();
				 }			 
			 }			 
			 
			}
		}	
		
//----------------------------------------------------------
		public static function drawAll():void
		{	
			var e:Effect;
			for (var i:int = 0; i < activeEffects.length; i++) 
			{
				e= activeEffects[i];
				RunGame.canvas.draw(e);
			}
		}			
		
//----------------------------------------------------------	
		public final function toCashe():void
		{
			this.visible =false;				
			cashe[this.type].push(this);
			
		}

		public static function getOne(type:int =0, x:int=0, y:int =0):void
		{

			var e:Effect ;
			if (cashe[type]==undefined) 
			{
				cashe[type] = []; 
				e = new Effect(type);	
			}		
			else
			{
				e= cashe[type].shift();
				if (!e)
				{
					e = new Effect(type);	
				}	
			} 			
				e.xx= x;
				e.yy= y;
					
			e.repeats  = e.repeatCount;
			e.animCounter =0;		
			e.active  =true;
			e.visible =true;
			e.alpha =0.999;
			activeEffects.push(e);	
		}			
		
//----------------------------------------------------------------------		
	}
}