package gameClasses
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.utils.Dictionary;
	
	import starling.display.Image;

	public class Map
	{
		
		public static  var 		renderMap:Array =[];    
		public static  var 		collisionMap:Array =[]; 
		public static  var 		tilesCashe:Dictionary  = new Dictionary();		
		
		public static var		maxCX:uint;  
		public static var		maxCY:uint;
		
		public static var		maxXX:uint;  
		public static var		maxYY:uint;
		
		public static var		maxRenderCellsX:int;  
		public static var		maxRenderCellsY:int;  
		
		public static var		tileSize:int =32; //размер тайла
		public static var		PTTSize:int =5;  
		
		
		
		public function Map()
		{
			super();
			createMap_func();			
		}
		
		//---------------------------------------------------------------
		private  function createMap_func():void
		{
			var tileNum:uint;
			var texName:String;
			var mapBD:BitmapData = Assets.mapBD;
			
			var mapHeight:int =mapBD.height;
			var mapWidth:int = mapBD.width;	
			
			maxCX = mapWidth;  
			maxCY = mapHeight;
			
			maxXX = (maxCX<<5)-GS.gameWidth; 
			maxYY = (maxCY<<5)-GS.gameHeight;
			
			for (var i:uint=0; i<= mapHeight; i++) 
			{
				var tmpArr:Array =[];
				var tmpArr1:Array =[];
				for (var n:int=0; n <= mapWidth ;n++) 
				{
					tmpArr.push(0); 
					tmpArr1.push(undefined);
				}
				collisionMap.push(tmpArr);
				renderMap.push(tmpArr1);
			}	
			
			var y:int;
			var x:int;
			var rs:Number;
			var rndBlock:int;
			var tmpColorR:uint;
			var tmpColorL:uint;
			for ( y= 0; y < maxCY; y++)
			{
				for ( x = 0; x < maxCX; x++)
				{
					tileNum = mapBD.getPixel(x,y);	
					if (tileNum==0xffffff || tileNum==0x0000ff)
					{
						collisionMap[y][x]   = 100; 				
					}
					else if (tileNum==0) 
					{
						rndBlock = Math.random()*3;
						if (tilesCashe[tileNum]==undefined)	tilesCashe[tileNum]= new Image(Assets.getAtlas().getTexture("tiles_01"));
						renderMap[y][x]			= tilesCashe[tileNum]; 
						collisionMap[y][x]      = 0; 
					}
					
					else if(tileNum==0xff0000) 
					{
						if (tilesCashe[tileNum]==undefined)	tilesCashe[tileNum]= new Image(Assets.getAtlas().getTexture("tiles_02"));
						renderMap[y][x]			= tilesCashe[tileNum]; 
						collisionMap[y][x]      = 2; 
					}
				}
			}			
		}		
		public static function hasCollision(cx:int,cy:int):Boolean 
		{
			if (cx>= maxCX ||cx<0 || cy>=maxCY || cy<0) return	true;
			if ( collisionMap[cy][cx]!=0 ) return	true;
			else return false;
		}	
		private static var testVector:Vector.<uint> = new Vector.<uint>;
		
		public static function destroyBlock(cx:int, cy:int):void
		{
			if (cx>= maxCX ||cx<0 || cy>=maxCY || cy<0) return;
			
			renderMap[cy][cx] =undefined;
			collisionMap[cy][cx] =100;
		}		
	}
}