package gameClasses
{
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	import starling.display.MovieClip;
	import starling.display.Quad;
	import starling.textures.Texture;
	
	public class Mob extends MovieClip
	{
		public  var  type:int =0;
		private var resetCounter:int;
		public var naked:Boolean =false;
		public var freezed:Boolean= false;
		
		public var active:Boolean =true;
		public  var cx	: int;
		public  var cy	: int;
		public var xr			: Number; 
		public var yr			: Number; 
		
		public var dx			: Number; 
		public var dy			: Number;
		public var xx			: Number; 
		public var yy			: Number;
		
		private var animation:Array = [0,0,0,1,1,1,1,2,2,2,3,3,3];
		private var animCounter:int =0;
		
		private var rndTimer:int;

		public  var health:int = 100;
		public  var energy:int = 0;
		
		public var curState: int;
		private  var texSpacer:int =0;
		
		public  var shooting:Boolean = false;
		public  var shootingCounter:int;
		

		
		public var maxSpeed:Number = 0.11;
		public var acceleration:Number = 0.03+Math.random()*0.02;	
		public var v_acceleration:Number = acceleration/2; 
		
		public var onGround:Boolean;
		public var hitRect:Rectangle;
		
		public static var	activeMobs:Array 	=[];
		private static var 	cashe:Array 		=[];
		public static var 	disposition:Array 	=[];
		
		private static var testQuad:Quad = new Quad(28,8,0x00ff00);	
		
		private var destPoint:Point;//  точка назначения
		private var thinkTimer:int;
		private var thinkTimerBase:int;
		private var rndSeed:Number;
		
		
		public function Mob(type:int =0)
		{
			super(Assets.getAtlas().getTextures("girl_"), 10);
			this.alpha = 0.999;
			cx = Math.random() *10;
			cy = 3+ Math.random() *5;
			
			thinkTimer = 60+Math.random()*45; 
			thinkTimerBase = thinkTimer;
			destPoint=new Point(cx*32,cy*32);
			
			xr = yr = 0.5;
			dx = dy = 0;
			curState=0;
			onGround =false;
			
			texSpacer= 0;
			
			this.currentFrame = 0;	
			hitRect = new Rectangle(this.x, this.y, 28, 8);
		}
		//--------------------------------------------------------------
		
		public static function updateAll():void
		{
			var m:Mob;			
			var al:int = activeMobs.length; 
			for (var i:int = 0; i < al; i++) 
			{
				m= activeMobs[i];
				if (m.active)
				{
					m.update();
				}
				else
				{	activeMobs.splice(i,1);			
					m.toCashe();
					al--;					
				}				
			}
		}

		//-----------------------------------------
		[Inline]
		private static function compare(m0:Mob, m1:Mob) : int
		{
			if (m0.yy < m1.yy)
			{
				return -1;
			}
			else if (m0.yy >= m1.yy)
			{
				return 1;
			}
			else return 0;
		}
		
		
		//-----------------------------------------------------------		
		public static function drawAll():void
		{
			var m:Mob;
			var al:int =activeMobs.length; 
			for (var i:int = 0; i < al; i++) 
			{
				m= activeMobs[i];
				if (m.xx > RunGame.viewPoint.x-32 && m.xx <RunGame.viewPoint.x+512  && m.yy > RunGame.viewPoint.y)
				{	RunGame.canvas.draw(m);
				}
				
			}			
		}	
		
		//------------------------------------------------------------
		public static function clear():void
		{
			var e:Mob;
			for (var i:int = 0; i < activeMobs.length; i++) 
			{
				e= activeMobs[i];			
				e.toCashe();
			}	
			activeMobs.length  =0;
			disposition.length =0;
			
		}			
		//-----------------------
		public function changeAnimState(state:int):void
		{		
			switch (state)
			{
				case 0:
					animation =  [5,5,5,5,5,5,5,5,5];
					break;
				case 1:
					animation =  [0,0,1,1,2,2,3,3,4,4,5,5];
					break;
				case 2:
					animation =  [22,22,22,22,22,22,22,22,22];
					animCounter=0;
					break;
				case 3:
					animation =  [23,23,23,23,23,23];
					break;
				case 4:
					animation =  [6,6,7,7,8,8,9,9,10,10];
					animCounter=0;
					break;

				
				//----------------------			
				case 10:
					animation = [16,16,16,16,16,16];
					break;
				case 11:
					animation = [11,11,12,12,13,13,14,14,15,15,16,16];
					break;
				case 12:
					animation = [24,24,24,24,24,24,24,24,24,24];
					animCounter=0;
					break;
				case 13:
					animation = [25,25,25,25,25,25,25];
					break;
				case 14:
					animation =  [17,17,18,18,19,19,20,20,21,21];
					animCounter=0;
					break;

			}				
			
			
			curState = state; //обновляем текущее состояние	
		}
		
		
		//-----------------------
		public function update():void
		{
			rndSeed = Math.random();		
			if (health>0 )
			{	
				var frictY:Number = 0.94;
				var gravity:Number = 0.04;
				xr+=dx;
				if( Map.hasCollision(cx-1,cy) && xr<=0.1 ) {
					dx = 0;
					xr = 0.1;

				}
				if( Map.hasCollision(cx+1,cy) && xr>=0.5 ) {
					dx = 0;
					xr = 0.5;
				}
				while( xr<0 ) {
					cx--;
					xr++;
				}
				while( xr>1 ) {
					cx++;
					xr--;
				}
				yr+=dy;
				dy*=frictY;
				if( Map.hasCollision(cx,cy-1) && yr<=0.1 ) {
					dy = 0;
					yr = 0.1;
				}
				if( Map.hasCollision(cx,cy+1) && yr>=0.5 ) {
					if (onGround) 
					{
						dy  = 0;
						yr = 0.5;
					}

				}
				else
				{
					onGround=false;
				}
				
				
				while( yr<0 ) {
					cy--;
					yr++;
				}
				while( yr>1 ) {
					cy++;
					yr--;
				}
				
				
				xx = int((cx+xr)*32);
				yy = int((cy+yr)*32);		
				
				x = xx-RunGame.viewPoint.x;
				y = yy-RunGame.viewPoint.y;
				
				
				if ( Map.collisionMap[yy>>5][xx>>5]==200) 
				{
					health =0;
					dx = 0;
					dy = 0;					
					Map.collisionMap[yy>>5][xx>>5]=100; 
				}
				else if ( Map.collisionMap[yy>>5][xx>>5]==201) 
				{
				}

				x-=23; 	y-=54;
				
				
				hitRect.x = this.xx-6;
				hitRect.y = this.yy;

			}
			else  
			{
				dx = 0;
				dy = 0;
			}

			if (animCounter < this.animation.length)
			{							
				this.currentFrame = this.animation[animCounter]+texSpacer;		
				animCounter++;				
			}
			else
			{
				animCounter =0;
				if (curState== 2)
				{
					changeAnimState(3);
					dx = dy = 0;
					Effect.getOne(5,cx*32+8, cy*32+8);
					Assets.fall.play();
				}
				else if (curState==12)
				{
					changeAnimState(13);
					dx = dy = 0;
					Effect.getOne(5,cx*32+8, cy*32+8);
					Assets.fall.play();
				}
				else if (curState==4)
				{					
					changeAnimState(1);
					this.freezed = false;
					Bullet.getOne(0, this.xx+15, this.yy+3);
				}
				else if (curState==14)
				{
					changeAnimState(11);
					this.freezed = false;
					Bullet.getOne(1, this.xx-5, this.yy+3);
				}
				
			}	
			if  (!this.naked && !this.freezed)
			{
				
				if (this.yy < this.destPoint.y ) this.dy = v_acceleration
				else if (this.yy >  this.destPoint.y)  this.dy =-v_acceleration
				else this.dy=0;
				
				if (this.xx < this.destPoint.x ) this.dx = acceleration
				else if (this.xx >  this.destPoint.x)  this.dx =-acceleration
				else this.dx=0;
				
				//-----------------------------------------------
				this.thinkTimer --;
				if (thinkTimer<0)
				{
					thinkTimer = thinkTimerBase;
					activeMobs.sort(compare);
					
					if (this.type ==1)
					{
					  if (Math.random()>0.5) this.destPoint.x = Man.xx + (128+rndSeed*50) else  this.destPoint.x = Man.xx - (128+rndSeed*50);
					  this.destPoint.y = Man.yy;
					}					
					if (this.xx < Man.xx ) this.changeAnimState(1) else this.changeAnimState(11);					
					if (this.yy == Man.yy) shoot();
				}
			}			
		}		
		
		//----------------------------------------------------------	
		final public function toCashe():void
		{
			cashe[this.type].push(this);

		}		

		public static function getOne(type:int =0, cx:int=0, cy:int =0):Mob
		{
			var rndSeed:Number = Math.random();
			var m:Mob ;
			if (cashe[type]==undefined) 
			{
				cashe[type] = []; 
				m = new Mob(type);	
			}		
			else
			{
				m= cashe[type].shift();
				if (!m)
				{
					m = new Mob(type);	
				}	
			} 			
			
			m.type = type;
			m.xx= cx*32;
			m.yy= cy*32;			
			
			m.hitRect.x =m.xx-6;
			m.hitRect.y =m.yy;
			m.cx = 2+ Math.random() *10;
			m.cy = 3+ Math.random() *4;			
			m.xr = m.yr = 0.5;
			m.dx = 0;
			m.dy = 0;
			m.health =100;
			m.rndTimer = 30+Math.random()*30;
			m.animCounter =0;		
			m.active  =true;
			m.naked  =false;
			m.alpha =0.999;
			m.energy =0;
			m.changeAnimState(1);
			m.destPoint.x= m.xx;
			m.destPoint.y= m.yy;	
			activeMobs.push(m);			
			return m;
		}	
//----------------------------------------------------

		public function getHit(dest:int, dmg:int=20):void
		{			
			this.health -=dmg;
			if (this.health >=0 )
			{
				if (dest ==0) 
				{
					this.dx+=0.4;
				}
				else  
				{
					this.dx-=0.4;
				}
			}
			else
			{
				this.health =1;
				this.naked = true;
				if (dest ==0) 
				{
					this.dx =  0.2+Math.random()*0.2;
					this.dy = -0.02+Math.random()*0.04;
					changeAnimState(12);
					Effect.getOne(10,cx*32+32, cy*32+8);
				}
				else  
				{
					this.dx = -0.2+ Math.random()*-0.2;
					this.dy = -0.02+Math.random()*0.04;
					changeAnimState(2);
					Effect.getOne(10,cx*32+8, cy*32+8);
				}
			}
	
			
			
		}	
		
//--------------------------------------------------------------
		private function shoot():void
		{
			if (this.xx < Man.xx ) this.changeAnimState(4) else this.changeAnimState(14);
			this.freezed = true;
			this.dx =0;
			this.dy =0;
			Assets.shoot_sound.play();
		
		}
	}
}