package gameClasses
{
	import starling.display.Quad;
	
	public class Spark extends Quad
	{
		
		public  var type:int; //тип частицы  		
		private var idx:Number;
		private var idy:Number;
		
		private var dx:Number;
		private var dy:Number;
		
		public  var  xx:int;
		public  var  yy:int;
		
		private var rDelta:Number;
		public  var active:Boolean;
		
		public var gravity:Number=0;
		public var collisionsChk:Boolean = false;
		
		public function Spark()
		{
			super(7, 7, 0xFF00FF00);		
			this.dx = this.idx = myRandom(-2,2);
			this.dy = this.idy = myRandom(-2,2);
			this.rDelta = Math.random()*0.5;
			this.alpha =0.75;
			this.active =true;
		}		
		
		final public function update():void
		{
			switch (this.type)
			{
				case 0:
					this.dy+=this.gravity;	
					this.xx += this.dx;
					this.yy += this.dy;					
					this.x= this.xx - RunGame.viewPoint.x;
					this.y= this.yy - RunGame.viewPoint.y;					
					this.rotation+=this.rDelta;
					this.scaleX -=0.03;
					this.scaleY -=0.03;		
					if (this.scaleX <=0)this.active =false;
					break;
				case 1:
					this.dy+=this.gravity;					
					this.xx += this.dx;
					this.yy += this.dy;					
					this.x= this.xx - RunGame.viewPoint.x;
					this.y= this.yy - RunGame.viewPoint.y;					
					this.scaleX -=0.03;
					this.scaleY -=0.03;		
					if (this.scaleX <=0)this.active =false;
					break;
				case 2:
					break;			
			}
			
			RunGame.canvas.draw(this);
			
		}	
		
		final public function reset(type:int):void
		{
			this.scaleX =this.scaleY =1;
			this.type =type;
			this.rotation =0;
			this.active =true;
			this.dx = this.idx; 
			this.dy = this.idy;
			this.alpha =0.75;
		}
		
		//-----------------------------------------------
		[Inline]
		final protected  function myRandom(min:Number,max:Number):Number 
		{
			return min+Math.random()*(max-min);
		}				
		
	}
}